package examen.horloge;

import java.util.List;
import java.util.ArrayList;
import java.time.LocalTime;

public class Horloge extends Thread {
  private Heure heure;
  private List<EcouteurHorloge> ecouteurs;

  public Horloge() {
    ecouteurs = new ArrayList<>();
  }

  public void addEcouteurHorloge(EcouteurHorloge ecouteur) {
    ecouteurs.add(ecouteur);
  }

  public void removeEcouteurHorloge(EcouteurHorloge ecouteur) {
    ecouteurs.remove(ecouteur);
  }

  public void run() {
    while (true) {
      LocalTime heureJava = LocalTime.now();
      adaptationHeure(heureJava);
      try {
        Thread.sleep(100);
      } catch (InterruptedException e) {
        System.err.println("pause interrompue");
      }
    }
  }

  private void adaptationHeure(LocalTime heureJava) {
    Heure heureActuelle = new Heure(heureJava);
    if (!heureActuelle.equals(heure)) {
      heure = heureActuelle;
      // prévenir les écouteurs enregistrés
      for (EcouteurHorloge ecouteur : ecouteurs) {
        ecouteur.heureModifiee(this);
      }
    }
  }

  public Heure getHeure() {
    return heure;
  }
}
